%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Dette er en forenklet versjon av beregn_bounds som ble produsert i
% forbindelse med jobb2006
%
% Einar Hauge
% 26.september 2006
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [bound_S, bound_T, bound_KS]=beregn_bounds(G,dist_zeros,dist_poles)
%=========================================================================\
% Bounds on S and T in the SISO-case se side 224 i S&P
%=========================================================================/
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Her ville jeg prve  finne de distinkte polene automatisk! men det ble
% problemer fordi matlab ikke finner polene eksakt! derfor byr det p
% problemer  benytte seg av funksjonen unique p en tabell!.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [num_Gdms, den_Gdms]=tfdata(Gdms,'v');
% roots(num_Gdms)
% roots(den_Gdms)
% %skal finne distinkte poler!!!!!!!!!
% [num_h, den_h]=tfdata(h,'v');
% dist_zeros=unique(roots(num_h)');
% dist_poles=unique(roots(den_h)');
[Qz, Qp, Qzp]=finn_Qz_Qp_Qzp(dist_zeros, dist_poles);
bound_S=sqrt(1+max((svd(sqrtm(pinv(Qz))*Qzp*sqrtm(pinv(Qp)))))^2);
bound_T=bound_S;        
%=========================================================================\
% Bounds on KS in the SISO-case
%=========================================================================/
%The Hankel-norm
[hankel_stab,hankel_unstab] = hankelsv(G);
if(length(hankel_unstab)==0)
    bound_KS=0;
else    
    bound_KS=1/min(hankel_unstab);
end