%=========================================================================\
% Linear combination of y= W + alpha * rhoT
%=========================================================================/

clear
clc
close all

s=tf('s');
W_tf=-1.0259e-7*((1.02*1e10*s-1)*(2681*s+1)*(0.393*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1));
rhoT_tf=-14.73*((253.5*s-1)*(2321*s+1))/((0.494*s+1)*(9009*s^2-71.8*s+1));




alpha=-0.2;
K_indre=5;
K_ytre=0.01;
Ti=100000;

G_linkomb=W_tf+alpha*rhoT_tf;
G_linkomb=minreal(G_linkomb);

open_loop_linkomb=loopsens(G_linkomb,K_indre)

figure
nyquist(K_indre*G_linkomb)

if(open_loop_linkomb.Stable==1)
    disp('indre slyfe stabil')
else
    disp('indre slyfe IKKE stabil')
end




simtid=70000;
[num_Wtf,den_Wtf]=tfdata(W_tf,'v');
[num_rhoT_tf,den_rhoT_tf]=tfdata(rhoT_tf,'v');
 sim('real_ex_linkomb_W_and_rhoT_simulink')
 
 
 
 
 
 

 
 %=========================================================================\
% Plots
%=========================================================================/

figure
subplot(1,2,1)
% plot(simout_linkomb.time, simout_linkomb.signals.values,'r','linewidth',1.5)
plot(simout_linkomb.time, simout_linkomb.signals.values,'linewidth',1.5)
ylabel('y=\alpha \rho _T + W')


subplot(1,2,2)
plot( simout_rhoT_tf.time,  simout_rhoT_tf.signals.values,'linewidth',1.5)
ylabel('y=\rho _T')


figure
plot(simout_linkomb_linkombonly.time, simout_linkomb_linkombonly.signals.values,'linewidth',1.5)
ylabel('y=\alpha \rho _T + W')




[a,b,c,d]=linmod('real_ex_linkomb_W_and_rhoT_simulink');
TF_r_y1_OL_simulink=ss(a,b,c,d);
TF_r_y1_OL_simulink=minreal(TF_r_y1_OL_simulink);
TF_r_y1_OL_simulink_tf=tf(TF_r_y1_OL_simulink);

pole(TF_r_y1_OL_simulink_tf)

 
 
 
 
 