close all;
s=tf('s');


P1=-13.37*(324.4*s+1)/((0.494*s+1)*(9009*s^2-71.8*s+1));
[num_P1,den_P1] = tfdata(P1,'v');
%-------------------------------------------------------------------------\
% Beregn bounds
%-------------------------------------------------------------------------/
P1_zeros=tzero(P1)
P1_poles=pole(P1)
[bound_S, bound_T, bound_KS]=beregn_bounds(P1,P1_zeros,P1_poles)
%-------------------------------------------------------------------------\
% H-infinity loop-shaping controller
%-------------------------------------------------------------------------/
[K,CL,GAM,INFO]=loopsyn(P1,1/s);
K_minreal=minreal(K)
K_tf=tf(K_minreal)
%-------------------------------------------------------------------------\
% P-controller 
%-------------------------------------------------------------------------/
%LOOPTRANSFER = LOOPSENS(P,C)
% figure
% bode(P1*K)
% % 
% K=-1
% simtid=100;
% sim('test_sim');
% figure
% plot(simout_maaling.time,simout_maaling.signals.values)




