
%=========================================================================\
%Et program for  forst forskjell p nullpunkter i HHP og VHP i
%nyquist-diagrammet
%=========================================================================/
close all

s=tf('s');
DP2=-4.45*((0.9020*s-1)*(83.51*s-1))/((0.494*s+1)*(9009*s^2-71.8*s+1));

%----------------------------------
% Regulering av DP2, Alene
%----------------------------------
k_dp2_s=0.2; %0.2
k_dp2_us1=0.1;
k_dp2_us2=0.3;

dp2_cl_s=loopsens(DP2,k_dp2_s);
dp2_cl_us1=loopsens(DP2,k_dp2_us1);
dp2_cl_us2=loopsens(DP2,k_dp2_us2);

figure
nyquist(dp2_cl_s.Li)
hold on
nyquist(dp2_cl_us1.Li,'--')
nyquist(dp2_cl_us2.Li,':')



figure
bode(dp2_cl_s.Li)



figure
step(dp2_cl_s.Ti)



