
%=========================================================================\
% Bounds on G1 and G2
%=========================================================================/

num_G1=5*[-1.5 1];
den_G1=[-1 1];
num_G2=5*[-0.5 1];
den_G2=[-1 1];
G1=tf(num_G1,den_G1);
G2=tf(num_G2,den_G2);
disp('------------------------------------------------------')
disp('Bounds on G1')
[bound_S_G1, bound_T_G1, bound_KS_G1]=beregn_bounds(G1,tzero(G1),pole(G1))
disp('------------------------------------------------------')
disp('Bounds on G2')
[bound_S_G2, bound_T_G2, bound_KS_G2]=beregn_bounds(G2,tzero(G2),pole(G2))


%=========================================================================\
% Bounds on the linear combination alpha*y1+y2
%=========================================================================/
alpha=-0.9;%-0.9;
H=alpha*G1+G2;
H_ss=ss(H,'min');
H_indre=tf(H_ss);

[num_linkomb,den_linkomb]=tfdata(H_indre);
disp('------------------------------------------------------')
disp('Bounds on the linear combination')
[bound_S_linkomb, bound_T_linkomb, bound_KS_linkomb]=beregn_bounds(H_indre,tzero(H_indre),pole(H_indre))

%=========================================================================\
% Bounds on the inner closed loop-corresponded to the outer loop???
%=========================================================================/
% K_indre=50;
% loop_indre=loopsens(H_indre,K_indre);
% inner_closed_loop=minreal(tf(loop_indre.Ti))
% H_ytre_OL=inner_closed_loop*K_ytre;