%=========================================================================\
% Shows how performance is lost due to the placement of the RHP-zero.
%=========================================================================/
%I must show this result to Hkon...because I think this does not
%correspond well with the requirement Re(pi)-Re(zi)
close all

s=tf('s');

rho_T=-0.0076*(253.5*s-1)/((0.494*s+1)*(9009*s^2-71.8*s+1));
rho_T_zero_right=-0.0076*(25*s-1)/((0.494*s+1)*(9009*s^2-71.8*s+1));
rho_T_zero_right2=-0.0076*(2*s-1)/((0.494*s+1)*(9009*s^2-71.8*s+1));
rho_T_zero_left=-0.0076*(2535*s-1)/((0.494*s+1)*(9009*s^2-71.8*s+1));


figure
bode(rho_T)
hold on
bode(rho_T_zero_left)
bode(rho_T_zero_right)
bode(rho_T_zero_right2)
legend('Original','further left','further right','even further right')


figure
nyquist(100*rho_T)