
%=========================================================================\
%Et program for  forst forskjell p nullpunkter i HHP og VHP i
%nyquist-diagrammet
%=========================================================================/
close all

s=tf('s');
rho_T=-14.73*(253.5*s-1)*(2321*s+1)/((0.494*s+1)*(9009*s^2-71.8*s+1));
tau_d=0.3

%----------------------------------
% Regulering av rhoT, Alene
%----------------------------------
k_rho_T_s=0.01; %0.2
%k_dp2_us1=0.1;
%k_dp2_us2=0.3;



rho_T_cl_s=loopsens(rho_T,k_rho_T_s);
%dp2_cl_us1=loopsens(DP2,k_dp2_us1);
%dp2_cl_us2=loopsens(DP2,k_dp2_us2);

if(rho_T_cl_s.Stable==1)
    disp('closed loop is STABLE')
else
    disp('closed loop is NOT stable')
end

figure
nyquist(rho_T_cl_s.Li)
hold on
% nyquist(dp2_cl_us1.Li,'--')
% nyquist(dp2_cl_us2.Li,':')


figure
bode(rho_T_cl_s.Li)

% figure
% bode(dp2_cl_s.Li)